void disp_send(unsigned char cmd, unsigned char type);
__inline void LCD_CtrlWrite_IC(unsigned char c);
void  LCD_DataWrite_IC(unsigned char c);
void disp_reset (void);

void dly_ms (unsigned int del);
void wait_1ms (void);
void delay_cyc(unsigned int number);

void i2c_start (void);
void i2c_restart (void);
void i2c_stop (void);
void i2c_write (unsigned char data);
unsigned char i2c_read (unsigned char ack_bit);

unsigned long read_keys (void);
void set_exp_local (unsigned int data);
void set_exp_rem (unsigned int data);
unsigned int get_gm_count (void);
void set_gain_chnl (unsigned char chnl, unsigned char gain_A, unsigned char gain_B);

#define PB_CLK    16000000

#define        DISP_RST    LATAbits.LATA10
#define        DISP_CS        LATBbits.LATB12
#define        DISP_CD        LATBbits.LATB13
#define        DISP_RST_T        TRISAbits.TRISA10
#define        DISP_CS_T        TRISBbits.TRISB12
#define        DISP_CD_T        TRISBbits.TRISB13

#define        KPS            LATAbits.LATA3
#define        KCK            LATAbits.LATA2
#define        KOUT        PORTCbits.RC2
#define        KPS_T        TRISAbits.TRISA3
#define        KCK_T        TRISAbits.TRISA2
#define        KOUT_T        TRISCbits.TRISC2

#define        LED_S        LATCbits.LATC0
#define        LED_S_T        TRISCbits.TRISC0
#define        LED_C        LATCbits.LATC1
#define        LED_C_T        TRISCbits.TRISC1

#define        ELDAT        LATAbits.LATA4
#define        ELDAT_T        TRISAbits.TRISA4
#define        ELCK        LATAbits.LATA9
#define        ELCK_T        TRISAbits.TRISA9


#define		EK1		PORTBbits.RB5
#define		EK2		PORTCbits.RC5
#define		EK3		PORTCbits.RC4
#define		EK4		PORTCbits.RC3
#define		EK1_T		TRISBbits.TRISB5
#define		EK2_T		TRISCbits.TRISC5
#define		EK3_T		TRISCbits.TRISC4
#define		EK4_T		TRISCbits.TRISC3

#define CSA1		LATCbits.LATC6
#define CSA2		LATCbits.LATC7
#define CSA1_T		TRISCbits.TRISC6
#define CSA2_T		TRISCbits.TRISC7



#define		GMON	LATBbits.LATB4
#define		GMON_T	TRISBbits.TRISB4



#define	SENS_PRES_START	0
#define SENS_PRES_WAIT 1


void iic_write_reg (unsigned char hw_addr, unsigned char addr, unsigned char data);
unsigned char iic_read_reg (unsigned char hw_addr, unsigned char addr);
unsigned char sens_pres_get (unsigned char * state, unsigned long * pressure, char * temperature);
unsigned char measure_hum (void);
void init_temp_sens (void);
int measure_temp (void);

#define	ADC_LEN 128


