#include <xc.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "disp.h"
#include "hw.h"
#include "other.h"

/*
0x3A - MMA7455
0x3C - MHC5883L
0xC0 - MPL3115A2
0x4E - HIH6130
0x90 - MCP9800
0xAE - 24LC64
*/

extern kvar keys_new,keys_old,keys;

unsigned long a;

unsigned char graph_vals[64] = {1,5,7,14,25,50,78,92,60,30,20,12,8,5,7,6,4,2,1,0,0,3,15,4,2,0,1,5,7,14,25,50,78,90,60,30,20,12,8,5,7,6,4,2,1,0,0,3,15,4,2,0};
unsigned char graph_vals_2[64] = {14,25,50,78,92,60,30,20,12,8,5,7,6,4,2,1,0,0,3,15,4,2,0,1,5,7,14,25,50,78,90,60,30,20,12,8,5,7,6,4,2,1,0,0,3,15,4,2,0};
volatile unsigned int i;
unsigned char line_mode;
unsigned char hum, temp,amplify;
unsigned int pres,gm_avg;

unsigned char pstring[50];

#define	GM_AVGS_COUNT	64
unsigned int gm_avgs[GM_AVGS_COUNT];
unsigned char gm_avgs_pointer;

extern volatile unsigned int adc_tmr;
extern volatile unsigned char adc_done;
extern volatile int adc_rets[ADC_LEN];


int fix_fft(short fr[], short fi[], short m, short inverse);
int fix_fftr(short f[], int m, int inverse);

short fft_in_arr[N_WAVE];
short fft_in_arr_i[N_WAVE];
short fft_in_arr_r[N_WAVE];
short fft_in_arr2[N_WAVE];
short fft_out_arr[N_WAVE/2];
volatile unsigned int i;
long tt1,tt2;

unsigned char gain_A, gain_B, chnl, gain_update, redraw, clear_screen;

unsigned char disp_mode;

void main (void)
{
amplify = 100;
init_mcu();
lcd_init ();
GMON_T = 0;
GMON = 1;

line_mode = 1;
//dsp_single_colour(0x0,0x0);

LCD_SetArea(0,0,160,128);
put_pixels(128*160,0);


/*
//draw_line(25,0,60,160,BLUE);
init_press_sens();
//init_temp_sens();
while (1)
	{
	pres = measure_pres();
//	hum = measure_hum();
//	temp = measure_temp();
//	temp = measure_temp();
	}
 */
a = 0;
set_exp_local(a);
gain_A = 0;
gain_B = 0;
chnl = 0;


while (1)
{
	if (clear_screen!=0)
	{
	clear_screen = 0;
	LCD_SetArea(0,0,160,128);
	put_pixels(128*160,0);

	}

	if (disp_mode==0)
	{
	if (gain_update==1)
		{
		gain_update = 0;
		set_gain_chnl(chnl, gain_A, gain_B);
		}

	adc_start();
	while (get_adc_state()==0);
			for (i=0;i<N_WAVE;i++)
			{
				tt1 = (adc_rets[i]-512)*amplify;

				if (i<(N_WAVE/2))
				{
					tt1 = tt1 * i;
					tt1 = tt1 / (N_WAVE/2);
				}
				else
				{
					tt1 = tt1 * (N_WAVE-i);
					tt1 = tt1 / (N_WAVE/2);
				}

				fft_in_arr_r[i] = tt1;
				fft_in_arr_i[i] = 0;

			}
			adc_start();
			i++;
			fix_fft(fft_in_arr_r,fft_in_arr_i,LOG2_N_WAVE,0);
			i++;

			for (i=0;i<N_WAVE/2;i++)
			{
				tt1 = fft_in_arr_r[i];
				tt1 = tt1*tt1;
				tt2 = fft_in_arr_i[i];
				tt2 = tt2*tt2;
				tt1 = tt1 + tt2;
				tt1 = sqrt(tt1);
				fft_out_arr[i] = tt1;
			}
			tt1 = i++;

			for (i=0;i<N_WAVE/2;i++)
			{
				graph_vals[i] = fft_out_arr[i]/60;
			}

			draw_graph(graph_vals,graph_vals_2,64,32,96,96,line_mode,RED,1);
			for (i=0;i<N_WAVE/2;i++)
				graph_vals_2[i] = graph_vals[i];
			set_exp_rem(a++);
			redraw++;
			if (redraw>10)
				{
				redraw = 0;
				sprintf (pstring,"spectrum analyser");
				print_str(pstring,14,0,0);
				sprintf (pstring,"GA:%d, GB%d, CHNL: %d", gain_A, gain_B, chnl);
				print_str(pstring,15,0,0);
				}
			if (keys.a)
			{
				keys.a = 0;
				gain_update=1;
				redraw = 10;
				if (gain_A<0x07) gain_A++;
				else gain_A = 0;
			}
			if (keys.b)
			{
				keys.b = 0;
				gain_update=1;
				redraw = 10;
				if (gain_B<0x07) gain_B++;
				else gain_B = 0;
			}
			if (keys.c)
			{
				keys.c = 0;
				redraw = 10;
				gain_update=1;
				if (chnl<4) chnl++;
				else chnl = 0;
			}

	}
	if (disp_mode==1)
	{
	if (gm_avgs_pointer==GM_AVGS_COUNT)
	{
	gm_avgs_pointer--;
	for (i=1;i<GM_AVGS_COUNT;i++)
		gm_avgs[i-1] = gm_avgs[i];
	}
	gm_avgs[gm_avgs_pointer++] = get_gm_avg_count()/8;
	for (i=0;i<GM_AVGS_COUNT;i++)
		graph_vals[i] = gm_avgs[i];
	draw_graph(graph_vals,graph_vals_2,GM_AVGS_COUNT,32,96,96,line_mode,RED,1);
	for (i=0;i<GM_AVGS_COUNT;i++)
		graph_vals_2[i] = graph_vals[i];
	gm_avg = get_gm_avg_count();
	sprintf (pstring,"GM counter: %d CPM    ",gm_avg);
	print_str(pstring,14,0,0);
	}

	if (disp_mode==2)
	{
	sprintf (pstring,"static sensor");
	print_str(pstring,14,0,0);
	}
	if (keys.INT!=0)
	{
		if (keys.s1) 
		{
			keys.s1 = 0;
			disp_mode = 0;
			clear_screen = 1;
			GMON = 1;

		}
		if (keys.s2)
		{
			keys.s2 = 0;
			disp_mode = 1;
			clear_screen = 1;
			GMON = 0;

		}
		if (keys.s3)
		{
			keys.s3 = 0;
			disp_mode = 2;
			clear_screen = 1;
			GMON = 1;

		}
	}
}


while (1)
{
if (gain_update==1)
	{
	gain_update = 0;
	set_gain_chnl(chnl, gain_A, gain_B);
	}

adc_start();
while (get_adc_state()==0);
		for (i=0;i<N_WAVE;i++)
		{
			tt1 = (adc_rets[i]-512)*amplify;

			if (i<(N_WAVE/2))
			{
				tt1 = tt1 * i;
				tt1 = tt1 / (N_WAVE/2);
			}
			else
			{
				tt1 = tt1 * (N_WAVE-i);
				tt1 = tt1 / (N_WAVE/2);
			}

			fft_in_arr_r[i] = tt1;
			fft_in_arr_i[i] = 0;

		}
		adc_start();
		i++;
		fix_fft(fft_in_arr_r,fft_in_arr_i,LOG2_N_WAVE,0);
		i++;

		for (i=0;i<N_WAVE/2;i++)
		{
			tt1 = fft_in_arr_r[i];
			tt1 = tt1*tt1;
			tt2 = fft_in_arr_i[i];
			tt2 = tt2*tt2;
			tt1 = tt1 + tt2;
			tt1 = sqrt(tt1);
			fft_out_arr[i] = tt1;
		}
		tt1 = i++;

		for (i=0;i<N_WAVE/2;i++)
		{
			graph_vals[i] = fft_out_arr[i]/60;
		}

		draw_graph(graph_vals,graph_vals_2,64,32,96,96,line_mode,RED,1);
		for (i=0;i<N_WAVE/2;i++)
			graph_vals_2[i] = graph_vals[i];
		set_exp_rem(a++);
}


while (1)
{
if (gm_avgs_pointer==GM_AVGS_COUNT)
	{
	gm_avgs_pointer--;
	for (i=1;i<GM_AVGS_COUNT;i++)
		gm_avgs[i-1] = gm_avgs[i];
	}
gm_avgs[gm_avgs_pointer++] = get_gm_avg_count()/8;
for (i=0;i<GM_AVGS_COUNT;i++)
	graph_vals[i] = gm_avgs[i];
draw_graph(graph_vals,graph_vals_2,GM_AVGS_COUNT,32,96,96,line_mode,RED,1);
for (i=0;i<GM_AVGS_COUNT;i++)
	graph_vals_2[i] = graph_vals[i];
gm_avg = get_gm_avg_count();
sprintf (pstring,"GM counter: %d CPM    ",gm_avg);
print_str(pstring,14,0,0);
}

iic_start();
iic_write(0xC0);
iic_stop();
a = 0xC0;
while (1)
    {
    iic_start();
    iic_write(a);
    iic_stop();
    }
}



